/* Copyright (C) 2001, 2009 United States Government as represented by
the Administrator of the National Aeronautics and Space Administration.
All Rights Reserved.
*/
package gov.nasa.worldwind.applications.gos.services;

import gov.nasa.worldwind.Configuration;
import gov.nasa.worldwind.applications.gos.*;
import gov.nasa.worldwind.avlist.AVList;

import javax.swing.*;
import java.net.URI;

/**
 * @author dcollins
 * @version $Id: RESTGeodataController.java 13555 2010-07-15 16:49:17Z dcollins $
 */
public class RESTGeodataController extends AbstractGeodataController
{
	public final String REST_SERVICE_URI = "gov.nasa.worldwind.gos.RestServiceURI";

    public RESTGeodataController()
    {
    }

    protected void doExecuteSearch(final AVList params) throws Exception
    {
        String service = Configuration.getStringValue(REST_SERVICE_URI);
        RESTRecordListRequest request = new RESTRecordListRequest(new URI(service), params);
        URI uri = request.getUri();

        if (Thread.currentThread().isInterrupted())
            return;

        final RecordList recordList = RESTRecordList.retrieve(uri);

        if (Thread.currentThread().isInterrupted())
            return;

        SwingUtilities.invokeLater(new Runnable()
        {
            public void run()
            {
                getGeodataWindow().setRecordList(recordList, params);
            }
        });
    }
}
